--- old/usr/src/uts/intel/io/acpica/osl.c	jeu. déc. 26 13:50:42 2013
+++ new/usr/src/uts/intel/io/acpica/osl.c	jeu. déc. 26 13:50:42 2013
@@ -22,14 +22,18 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
- * Copyright 2011 Joyent, Inc.  All rights reserved.
+ * Copyright 2012 Joyent, Inc.  All rights reserved.
+ * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2013 PALO, Richard. All rights reserved.
  */
+
 /*
  * Copyright (c) 2009-2010, Intel Corporation.
  * All rights reserved.
  */
+
 /*
- * ACPI CA OSL for Solaris x86
+ * x86 ACPI CA OSL
  */
 
 #include <sys/types.h>
@@ -48,7 +52,7 @@
 #include <sys/note.h>
 #include <sys/promif.h>
 
-#include <sys/acpi/accommon.h>
+#include <acpica/include/accommon.h>
 #include <sys/acpica.h>
 
 #define	MAX_DAT_FILE_SIZE	(64*1024)
@@ -315,6 +319,12 @@
 	return (AE_OK);
 }
 
+ACPI_STATUS
+AcpiOsPhysicalTableOverride(ACPI_TABLE_HEADER *ExistingTable,
+    ACPI_PHYSICAL_ADDRESS *NewAddress, UINT32 *NewTableLength)
+{
+	return (AE_SUPPORT);
+}
 
 /*
  * ACPI semaphore implementation
@@ -744,6 +754,22 @@
 }
 
 void
+AcpiOsWaitEventsComplete (void)
+{
+	if (acpica_eventq_init) {
+		int	i;
+		/*
+		 * blocks until all events initiated by AcpiOsExecute have completed
+		 */
+		for (i = OSL_GLOBAL_LOCK_HANDLER; i <= OSL_EC_BURST_HANDLER; i++) {
+			if (osl_eventq[i])
+				ddi_taskq_wait(osl_eventq[i]);
+		}
+	}
+    return;
+}
+
+void
 AcpiOsSleep(ACPI_INTEGER Milliseconds)
 {
 	/*
@@ -883,7 +909,7 @@
 
 
 static void
-osl_rw_memory(ACPI_PHYSICAL_ADDRESS Address, UINT32 *Value,
+osl_rw_memory(ACPI_PHYSICAL_ADDRESS Address, UINT64 *Value,
     UINT32 Width, int write)
 {
 	size_t	maplen = Width / 8;
@@ -902,6 +928,9 @@
 	case 4:
 		OSL_RW(ptr, Value, uint32_t, write);
 		break;
+	case 8:
+		OSL_RW(ptr, Value, uint64_t, write);
+		break;
 	default:
 		cmn_err(CE_WARN, "!osl_rw_memory: invalid size %d",
 		    Width);
@@ -913,7 +942,7 @@
 
 ACPI_STATUS
 AcpiOsReadMemory(ACPI_PHYSICAL_ADDRESS Address,
-		UINT32 *Value, UINT32 Width)
+		UINT64 *Value, UINT32 Width)
 {
 	osl_rw_memory(Address, Value, Width, 0);
 	return (AE_OK);
@@ -921,7 +950,7 @@
 
 ACPI_STATUS
 AcpiOsWriteMemory(ACPI_PHYSICAL_ADDRESS Address,
-		UINT32 Value, UINT32 Width)
+		UINT64 Value, UINT32 Width)
 {
 	osl_rw_memory(Address, &Value, Width, 1);
 	return (AE_OK);
